/**
***     webapp.hpp
***
***     Copyright (C) 2006 - 2008 SophiaCradle Incorporated.
***     All rights reserved.
***
***     ̃\[XR[h̓G[XgbvATXyhȂǂ̏Ă܂B
***     ۂ̎gpɍۂẮAKvɉďǉĂB
***
**/

#ifndef __WEBAPP_HPP
#define __WEBAPP_HPP

#include <SophiaFramework.hpp>
#include "webapp.bid"

SFMTYPEDEFCLASS(WebAction)
SFMTYPEDEFCLASS(webapp)
class WebAction {
    public:
        webappPtr _sfweb;
    private:
        SFBWebRespSmp _webresp;
        SFBGetLineSmp _getline;
        SFXCallback _callback;

    public:
        Void Start(ACharPtr url);
    private:
        XALLBACK_DECLARE_SFXCALLBACK(GotResp)
        Void Header(ACharConstPtr name, GetLine* val);
        Void Status(WebStatus status, VoidPtr val);
        XALLBACK_DECLARE_SFXCALLBACK(ReadLines)
        Void Stop(Void);

        static Void HeaderSHP(WebAction* p, ACharConstPtr name, GetLine* val)
        {
            p->Header(name, val);
            return;
        }
        static Void StatusSHP(WebAction* p, WebStatus status, VoidPtr val)
        {
            p->Status(status, val);
            return;
        }
};

class webapp : public SFYApplication {
    SFMSEALCOPY(webapp)
    public:
        SFXAnsiString _message;
        SFBWebSmp _web;
    private:
        WebAction _webaction;
        SFZTitleBevelFrameSmp           _frame;
        SFZWindowSmp                    _window;
        SFZMultipleTextLabelControlSmp  _label;
    public:
        Void SetLabelText(SFXWideString message);
        static SFCInvokerPtr Factory(Void);
    private:
        explicit webapp(Void) static_throws;
        virtual ~webapp(Void);
        XANDLER_DECLARE_BOOLEVENT(OnKey)
};

#endif // __WEBAPP_HPP //
